unit TextBox;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvToolBar, AdvToolBarExt,
  AdvRichEditorToolBar, AdvScrollControl, AdvRichEditorBase, AdvRichEditor, DB,
  Vcl.StdCtrls, AdvGroupBox, AdvRichEditorIO, AdvRichEditorMiniHTMLIO, VirtualKeyb,
  JclDebug,AdvOfficeComboBox;

type
  TfrmTextBox = class(TFrame)
    redText: TAdvRichEditor;
    AdvRichEditorFormatToolBar: TAdvRichEditorFormatToolBar;
    gbxKeyb: TAdvGroupBox;
    AdvRichEditorMiniHTMLIO: TAdvRichEditorMiniHTMLIO;
    Constructor Create(AOwner: TComponent; pTxtDataset:TDataSet = Nil; pTxtField:String = '';
                               UseKeyb:Boolean = False); Reintroduce;
    Destructor Destroy();
  private
    { Private declarations }
    TMSFontListComboBox: TAdvOfficeFontSelector;
    TMSFontSizeComboBox: TAdvOfficeFontSizeSelector;
    TxtDataset:TDataSet;
    TxtField:String;
  public
    { Public declarations }
    Procedure Insert_TextBox(Text_FileName:String = ''; UseFileName:Boolean = False);
    Function Get_TextBox(SaveTxtField:Boolean = False; SaveOnFileName:String = ''):String;
  end;

Const
  tbCLS = '_CLS'; // Clear screen

Var
  frmTextBox:TfrmTextBox;
  frmTextBoxKeyb:TfrmVirtualKeyb;

implementation

{$R *.dfm}

Constructor TfrmTextBox.Create(AOwner: TComponent; pTxtDataset:TDataSet = Nil; pTxtField:String = '';
                                       UseKeyb:Boolean = False);
Var i:Smallint;
  aControl: TControl;
  fontName:String;
begin
  Inherited Create(AOwner);

  Try
    gbxKeyb.Visible:=UseKeyb;

    If UseKeyb Then Begin
      frmTextBoxKeyb:=TfrmVirtualKeyb.Create(AOwner);
      //frmTextBoxKeyb.OwnerForm:=AOwner;
      frmTextBoxKeyb.ContainerPanel:=gbxKeyb;
      frmTextBoxKeyb.Call_VKeyb(KT_PAD, KM_EMBED);
    End;


  // Get a reference to the font ComboBoxes in AdvRichEditorEditToolBar
  for i := 0 to (AdvRichEditorFormatToolBar.ControlCount - 1) do begin
    if ((Assigned(TMSFontListComboBox)) and
        (Assigned(TMSFontSizeComboBox))) then begin
      break;
    end;
    aControl := AdvRichEditorFormatToolBar.Controls[i];
    if (aControl is TAdvOfficeFontSelector) then begin
      TMSFontListComboBox := TAdvOfficeFontSelector(aControl);
      continue;
    end;
    if (aControl is TAdvOfficeFontSizeSelector) then begin
      TMSFontSizeComboBox := TAdvOfficeFontSizeSelector(aControl);
      continue;
    end;
  end;



// Safely remove all non web compatible fonts from the FontListComboBox
  for i := (TMSFontListComboBox.Items.Count - 1) downto 0 do begin
    fontName := TMSFontListComboBox.Items[i];
    if ((fontName <> 'Arial') and
        (fontName <> 'Courier New') and
        (fontName <> 'Times New Roman') and
        (not(Assigned(TMSFontListComboBox.Items.Objects[i])))) then begin
      TMSFontListComboBox.Items.Delete(i);
    end;
  end;



    TxtDataset:=pTxtDataset;
    TxtField:=pTxtField;

    If TxtDataset <> Nil Then
      AdvRichEditorMiniHTMLIO.Insert(TxtDataset.FieldByName(TxtField).AsString);

  Finally
    // fa qualcosa
  End;
end;
// -----------------------------------------------------------------------------
Procedure TfrmTextBox.Insert_TextBox(Text_FileName:String = ''; UseFileName:Boolean = False);
Begin
  If Not UseFileName Then Begin
    If Text_FileName <> tbCLS Then
      AdvRichEditorMiniHTMLIO.Insert(Text_FileName)
    Else  // tbCLS
      redText.Clear();
  End Else // Text_FileName  un nome di file completo di percorso ...
    AdvRichEditorMiniHTMLIO.Load(Text_FileName);
End;
// -----------------------------------------------------------------------------
Function TfrmTextBox.Get_TextBox(SaveTxtField:Boolean = False; SaveOnFileName:String = ''):String;
begin
  Try
    Result:=AdvRichEditorMiniHTMLIO.AsString();

    // Faccio alcune eventuali elaborazioni del testo HTML

    // Per un difetto sulla gestione font mi mette all'inizio questo tag sbagliato !
    If UpperCase(Copy(Result,1,7)) = '</FONT>' Then
      Result:=Copy(Result,8,Length(Result));
    //  If Not ContainsText(LowerCase(HtmlStr),'face="verdana"') Then
    //    Insert(HtmlStr, 'face="verdana"',
    If SaveTxtField Then Begin
      With TxtDataset Do Begin
        If Not (State In [dsInsert, dsEdit]) Then
          Edit();
        FieldByName(TxtField).AsString:=Result;
        Post();
      End;
    End;

    If SaveOnFileName <> '' Then
      AdvRichEditorMiniHTMLIO.Save(SaveOnFileName);

  Except
    On E:Exception Do
      Raise Exception.Create(E.Message+'<br>Origine : '+ProcByLevel(0));
  End;
End;
// -----------------------------------------------------------------------------
Destructor TfrmTextBox.Destroy();
begin
  If Assigned(frmTextBoxKeyb)Then
    FreeAndNil(frmTextBoxKeyb);

  Inherited;
end;

end.
